/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
//http://stackoverflow.com/questions/6830478/programatically-reducing-jpeg-file-size
//https://developer.mozilla.org/en/Canvas_tutorial/Using_images  (how to use canvas to display an image and then draw on it)
package imageconverter;

import java.io.File;
import com.sun.media.jai.codec.SeekableStream;
import com.sun.media.jai.codec.FileSeekableStream;
import com.sun.media.jai.codec.TIFFDecodeParam;
import com.sun.media.jai.codec.ImageDecoder;
import com.sun.media.jai.codec.ImageCodec;
import com.sun.media.jai.codec.JPEGEncodeParam;
import com.sun.media.jai.codec.ImageEncoder;
import java.awt.image.RenderedImage;
import java.io.FileOutputStream;
import java.awt.image.BufferedImage;
import java.io.IOException;
import javax.imageio.ImageIO;
import com.thebuzzmedia.imgscalr.*;
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {
        // Look!!! This is being called to avoid command line parameters. This works only with jpegs
        if (Test.test()) return;

        BufferedImage bi;
        float quality = 0.50f;
        String type = args[0];

        String in = args[1];
        if (in.charAt(in.length()-1) != '/' && in.charAt(in.length()-1) != '\\') {
            in = in + "/";
        }

        String out = args[2];
        if (out.charAt(out.length()-1) != '/' && out.charAt(out.length()-1) != '\\') {
            out = out + "/";
        }
        if (args.length == 4) {
            quality = Float.parseFloat(args[3]);
        }
        //in = "C:\\Users\\ralph\\Documents\\PeterScharf\\Manuscripts\\tifs\\";
        // in = "C:\\Users\\ralph\\Documents\\temp\\mss\\jpg\\full\\";
        //out = "C:\\Users\\ralph\\Documents\\temp\\mss\\jpg\\size1_8\\";

/*
        createJPEGs();
        convert("C:\\Users\\ralph\\Documents\\temp\\mss\\jpg\\test\\ms_coll_390_item452_body0002_1.jpg",
                "C:\\Users\\ralph\\Documents\\temp\\mss\\jpg\\test\\ms_coll_390_item452_body0002_1.jpg", 600);
*/

        if (type.equals("tif")) {
            process(new File(in), in, out, quality);
        } else if (type.equals("jpg") || type.equals("jpeg")) {
            resizeImages(in, out, quality);
        } else {
            System.out.format("Illegal type: %s. Legal types are tif, jpg and jpeg\n", type);
        }
    }



    public static void createJPEGs () {
        MappingInfo[] mi = new MappingInfo[] {
          new MappingInfo(
                  "UPenn452",
                  new String[]{"C:\\Users\\ralph\\Documents\\temp\\annotations-5-10-2011\\annotations\\vizRusahasranAman\\UPenn\\mscoll390_item452_wk1\\"},
                  "C:\\Users\\ralph\\Documents\\temp\\mss\\jpg\\full\\mscoll390_item452\\"),

          new MappingInfo("UPenn488", 
                  new String[] {"C:\\Users\ralph\\Documents\\temp\\annotations-5-10-2011\\annotations\\MBh12ShantiParvan\\UPenn\\mscoll390_item488\\"},
                  "C:\\Users\\ralph\\Documents\\temp\\mss\\jpg\\full\\mscoll390_item488\\"),

          new MappingInfo("UPenn489",
                  new String[] {"C:\\Users\ralph\\Documents\\temp\\annotations-5-10-2011\\annotations\\MBh12ShantiParvan\\UPenn\\mscoll390_item488\\"},
                  "C:\\Users\\ralph\\Documents\\temp\\mss\\jpg\\full\\mscoll390_item489\\"),

          new MappingInfo("UPenn490",
                  new String[] {"C:\\Users\ralph\\Documents\\temp\\annotations-5-10-2011\\annotations\\MBh12ShantiParvan\\UPenn\\mscoll390_item488\\"},
                  "C:\\Users\\ralph\\Documents\\temp\\mss\\jpg\\full\\mscoll390_item490\\"),
        };
    }

    public static void convert(String anupamaImg, String displayImg, double displayHeight) {
        double anupamaLeftBracketLeft = 946;
        double anupamaLeftBracketTop = 385;
        double anupamaRightBracketLeft = 614;
        double anupamaRightBracketTop = 549;
        double displayLeftBracketLeft = 0.0;
        double displayLeftBracketTop = 0.0;
        double displayRightBracketLeft = 0.0;
        double displayRightBracketTop = 0.0;

        BufferedImage anupama = loadImage(anupamaImg);
        BufferedImage reduced = loadImage(displayImg);
        System.out.format("anupama.height=%d, reduced.height=%d\n", anupama.getHeight(), reduced.getHeight());
        System.out.format("anupama.width=%d, reduced.width=%d\n", anupama.getWidth(), reduced.getWidth());

        // location on reduced jpg
        double ratioReduced = ((double)reduced.getHeight())/((double)anupama.getHeight());
        displayLeftBracketLeft = anupamaLeftBracketLeft * ratioReduced;
        displayLeftBracketTop = anupamaLeftBracketTop * ratioReduced;
        displayRightBracketLeft = anupamaRightBracketLeft * ratioReduced;
        displayRightBracketTop = anupamaRightBracketTop * ratioReduced;


        // location in browser
        if (displayHeight != 0) {
            double ratioDisplay = displayHeight / ((double)reduced.getHeight());
            displayLeftBracketLeft = displayLeftBracketLeft * ratioDisplay;
            displayLeftBracketTop = displayLeftBracketTop * ratioDisplay;
            displayRightBracketLeft = displayRightBracketLeft * ratioDisplay;
            displayRightBracketTop = displayRightBracketTop * ratioDisplay;
        }

        System.out.format("\timg.start {position:absolute; left:%dpx; top:%dpx; z-index:2; opacity:1.0;}\n",
                (int)displayLeftBracketLeft, (int)displayLeftBracketTop);

        System.out.format("\timg.end {position:absolute; left:%dpx; top:%dpx; z-index:2; opacity:1.0;}\n",
                (int)displayRightBracketLeft, (int)displayRightBracketTop);
    }

    public static void process(File in, String inroot, String outroot, float quality) throws Exception {
        File[] files = in.listFiles();
        int count = 0;
        for (File file : files) {
            if (file.isDirectory()) {
                process(file, inroot, outroot, quality);
            } else {
                count++;
                String fn = file.getName();
                String filename = file.getAbsolutePath();
                String outfile = String.format("%s%s", outroot, filename.substring(inroot.length()));
                int fl = outfile.length() - fn.length();
                String op = outfile.substring(0, fl);
                File ofd = new File(op);
                if (!ofd.exists()) {
                    boolean b = ofd.mkdirs();
                    if (!b) {
                        System.out.format("mkdirs for %s failed.\n", op);
                    }
                }
                outfile = outfile.replace(".tif", ".jpg");
                FileOutputStream fos = null;
                try {
                    SeekableStream s = new FileSeekableStream(new File(filename));
                    TIFFDecodeParam param = null;
                    ImageDecoder dec = ImageCodec.createImageDecoder("tiff", s, param);
                    RenderedImage op1 = dec.decodeAsRenderedImage();
                    fos = new FileOutputStream(outfile);
                    JPEGEncodeParam jparam = new JPEGEncodeParam();
                    //quality = 0.5f;
                    jparam.setQuality(quality); // e.g. 0.25f
                    ImageEncoder encoder = ImageCodec.createImageEncoder("JPEG", fos, jparam);
                    encoder.encode(op1);
                    fos.close();
                    File ofa = new File(outfile);
                    System.out.format("%s: %d --> %d\n", file.getName(), file.length(), ofa.length());
                } catch (Exception ex) {
                    try {
                        if (fos != null) {
                            fos.close();
                        }
                    } catch (Exception exx) {}
                    System.out.format("Conversion of %s failed with error: %s\n", file.getName(), ex.getMessage());
                }
            }

        }
    }

    public static BufferedImage loadImage(String ref) {
        BufferedImage bimg = null;
        try {

            bimg = ImageIO.read(new File(ref));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return bimg;
    }

    public static void resizeImages (String in, String out, float quality) {
        File indirf = new File(in);
        resizeImages(indirf, in, out, quality);
    }


    public static void resizeImages(File in, String startin, String startout, float quality) {
        File[] files = in.listFiles();
        for (File file : files) {
            if (file.isDirectory()) {
                resizeImages(file, startin, startout, quality);
            } else {
                String fn = file.getName();                 // input file name (without directories)
                String filename = file.getAbsolutePath();   // complete input file name
                String outfile = String.format("%s%s", startout, filename.substring(startin.length()));
                int fl = outfile.length() - fn.length();
                String op = outfile.substring(0, fl);       // strip off file name from outfile path to get directory
                File ofd = new File(op);
                if (!ofd.exists()) {
                    boolean b = ofd.mkdirs();
                    if (!b) {
                        System.out.format("mkdirs for %s failed.\n", op);
                    }
                }
                outfile = outfile.replace(".tif", ".jpg");
                BufferedImage bi = loadImage(file.getAbsolutePath());
                BufferedImage bio = resize(bi, 3);   // 1/8=4, 1/4 = 3, 1/2 = 2
                System.out.format("%s\n\twidth %d->%d\n\theight %d->%d\n",
                                        file.getName(),
                                        bi.getWidth(), bio.getWidth(),
                                        bi.getHeight(), bio.getHeight());
                saveImage(bio, outfile);
            }
        }
    }


    public static BufferedImage resize(BufferedImage img, int n) {
        int dim = img.getHeight();
        if (dim > img.getWidth()) {
            dim = img.getWidth();
        }
        Scalr s = new Scalr();
        return Scalr.resize(img, dim/n);
    }

    public static void saveImage(BufferedImage img, String ref) {
        try {
            String format = (ref.endsWith(".png")) ? "png" : "jpg";
            ImageIO.write(img, format, new File(ref));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    static public class MappingInfo {
        public String manuscriptName;
        public String[] annotations;
        public String jpegs;

        public MappingInfo (String manuscriptName, String[] annotations, String jpegs) {
            this.manuscriptName = manuscriptName;
            this.annotations = annotations;
            this.jpegs = jpegs;
        }
    }
}
