package imageconverter;
/*
import com.sun.media.jai.codec.JPEGEncodeParam;
import com.sun.media.jai.codecimpl.JPEGCodec;
import com.sun.media.jai.codecimpl.JPEGImageEncoder;
 */
import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGEncodeParam;
import com.sun.image.codec.jpeg.JPEGImageEncoder;

import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import javax.imageio.ImageIO;

public class Test {
    public static boolean test () throws Exception {
        //String in = "E:/JPEGImages/UPenn/mscoll390_item349_wk1/";
        //String out = "reduced/";

        //String in = "/Users/ralph/SanskritLibrary/LatestGrantFiles/mss/Brown/";
        //String out = "/Users/ralph/OriginalFiles/Brown/";

        String in = "/Users/ralph/Downloads/Brown_s/";
        String out = "/Users/ralph/DongleiZones/Brown/";

        //String in = "/Users/ralph/SanskritLibrary/LatestGrantFiles/mss/UPenn/";
        //String out = "/Users/ralph/OriginalFiles/UPenn/";

        process (new File(in), in, out, .35f);
        return true;
    }

    public static void process(File in, String inroot, String outroot, float quality) throws Exception {
        File[] files = in.listFiles();
        int count = 0;
        for (File file : files) {
            if (file.isDirectory()) {
                System.out.format("Processing %s\n", file.getName());
                process(file, inroot, outroot, quality);
            } else {
                count++;
                String fn = file.getName();
                if (!fn.endsWith(".jpg")) {
                    continue;
                }
                String filename = file.getAbsolutePath();
                String outfile = String.format("%s%s", outroot, filename.substring(inroot.length()));
                int fl = outfile.length() - fn.length();
                String op = outfile.substring(0, fl);
                File ofd = new File(op);
                if (!ofd.exists()) {
                    boolean b = ofd.mkdirs();
                    if (!b) {
                        System.out.format("mkdirs for %s failed.\n", op);
                    }
                }

                BufferedImage original = loadImage(file.getAbsolutePath());
                int originalWidth = original.getWidth();
                int originalHeight = original.getHeight();
                int finalWidth = (int)(quality * originalWidth);
                int finalHeight = (int)(quality * originalHeight);
                Image scaled = original.getScaledInstance(finalWidth, finalHeight, Image.SCALE_SMOOTH); // scale the image to a smaller one
                BufferedImage image = new BufferedImage(finalWidth, finalHeight, original.getType());
                Graphics2D g = image.createGraphics();
                g.drawImage(scaled, 0, 0, null); //draw the smaller image
                g.dispose();
                OutputStream output = new FileOutputStream(outfile);


                JPEGImageEncoder jpegEncoder = JPEGCodec.createJPEGEncoder(output);
                JPEGEncodeParam jpegEncodeParam = jpegEncoder.getDefaultJPEGEncodeParam(image);

                jpegEncodeParam.setDensityUnit(JPEGEncodeParam.DENSITY_UNIT_DOTS_INCH);
                jpegEncodeParam.setXDensity(92);
                jpegEncodeParam.setYDensity(92);

                jpegEncodeParam.setQuality(0.8F, false);
                jpegEncoder.encode(image, jpegEncodeParam);


            }
        }
    }


    public static BufferedImage loadImage(String ref) {
        BufferedImage bimg = null;
        try {

            bimg = ImageIO.read(new File(ref));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return bimg;
    }


}
