/*
 * @(#)Arithmetic.java	1.11 01/03/19 13:54:25
 *
 * Copyright (c) 2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.awt.image.renderable.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.media.jai.*;


public class Arithmetic extends JPanel
                        implements ActionListener {

    private PlanarImage src1 = null;
    private PlanarImage src2 = null;
    private ImageDisplay ic1 = null;
    private ImageDisplay ic2 = null;
    private ImageDisplay ic3 = null;
    private JButton b1;
    private JButton b2;
    private JButton b3;
    private JButton b4;

    public Arithmetic(String im1, String im2) {
        super(true);
        setLayout(new BorderLayout());

        // load files
        src1 = ReadImage.getImage(im1);
        src2 = ReadImage.getImage(im2);

        // alter mask image a bit
        Byte[] bandValues = new Byte[3];
        bandValues[0] = new Byte((byte)2);
        bandValues[1] = new Byte((byte)2);
        bandValues[2] = new Byte((byte)2);

        ParameterBlock pb = new ParameterBlock();
        pb.add((float)src2.getWidth());
        pb.add((float)src2.getHeight());
        pb.add(bandValues);
        PlanarImage temp = JAI.create("constant", pb, null);

        pb = new ParameterBlock();
        pb.addSource(src2);
        pb.addSource(temp);

        src2 = JAI.create("add", pb, null);

        ic1 = new ImageDisplay(src1);
        ic2 = new ImageDisplay(src2);
        ic3 = new ImageDisplay(src1.getWidth(),
                               src1.getHeight());

        JPanel imagePanel = new JPanel();
        imagePanel.setLayout(new GridLayout(3,1,0,0));
        imagePanel.add(ic1);
        imagePanel.add(ic2);
        imagePanel.add(ic3);
        add(imagePanel, BorderLayout.CENTER);

        // control panel
        JPanel panel = new JPanel();
        panel.setLayout(new GridLayout(1,4,4,4));
        panel.setBorder(new EmptyBorder(10,10,10,10));

        b1 = new JButton("Add");
        b2 = new JButton("Subtract");
        b3 = new JButton("Multiply");
        b4 = new JButton("Divide");

        b1.addActionListener(this);
        b2.addActionListener(this);
        b3.addActionListener(this);
        b4.addActionListener(this);

        panel.add(b1);
        panel.add(b2);
        panel.add(b3);
        panel.add(b4);
        add(panel, BorderLayout.SOUTH);

        // GUI spacing
        add(new JLabel("          "), BorderLayout.WEST);
        add(new JLabel("          "), BorderLayout.EAST);
    }

    public void actionPerformed(ActionEvent e) {
        PlanarImage target = null;
        JButton b = (JButton)e.getSource();
        ParameterBlock pb = new ParameterBlock();
        pb.addSource(src1);
        pb.addSource(src2);

        if ( b == b1 ) {
            target = JAI.create("add", pb, null);
        } else if ( b == b2 ) {
            target = JAI.create("subtract", pb, null);
        } else if ( b == b3 ) {
            target = JAI.create("multiply", pb, null);
        } else if ( b == b4 ) {
            target = JAI.create("divide", pb, null);
        }

        ic3.set(target);
    }
}
